using System;
using System.Collections.Generic;
using Android.Runtime;

namespace Java.Interop {

	partial class __TypeRegistrations {

		public static void RegisterPackages ()
		{
#if MONODROID_TIMING
			var start = DateTime.Now;
			Android.Util.Log.Info ("MonoDroid-Timing", "RegisterPackages start: " + (start - new DateTime (1970, 1, 1)).TotalMilliseconds);
#endif // def MONODROID_TIMING
			Java.Interop.TypeManager.RegisterPackages (
					new string[]{
						"co/ronash/pushe",
						"com/evernote/android/job",
					},
					new Converter<string, Type>[]{
						lookup_co_ronash_pushe_package,
						lookup_com_evernote_android_job_package,
					});
#if MONODROID_TIMING
			var end = DateTime.Now;
			Android.Util.Log.Info ("MonoDroid-Timing", "RegisterPackages time: " + (end - new DateTime (1970, 1, 1)).TotalMilliseconds + " [elapsed: " + (end - start).TotalMilliseconds + " ms]");
#endif // def MONODROID_TIMING
		}

		static Type Lookup (string[] mappings, string javaType)
		{
			string managedType = Java.Interop.TypeManager.LookupTypeMapping (mappings, javaType);
			if (managedType == null)
				return null;
			return Type.GetType (managedType);
		}

		static string[] package_co_ronash_pushe_mappings;
		static Type lookup_co_ronash_pushe_package (string klass)
		{
			if (package_co_ronash_pushe_mappings == null) {
				package_co_ronash_pushe_mappings = new string[]{
					"co/ronash/pushe/Pushe:CO.Ronash.Pushe.PushePlugin",
				};
			}

			return Lookup (package_co_ronash_pushe_mappings, klass);
		}

		static string[] package_com_evernote_android_job_mappings;
		static Type lookup_com_evernote_android_job_package (string klass)
		{
			if (package_com_evernote_android_job_mappings == null) {
				package_com_evernote_android_job_mappings = new string[]{
					"com/evernote/android/job/JobBootReceiver:Evernote.AndroidJob.JobBootReceiver",
				};
			}

			return Lookup (package_com_evernote_android_job_mappings, klass);
		}
	}
}
